;Base	b812

.NOLIST
.NOCREF
.486
.model flat,stdcall
option casemap:none

WinMain	proto :DWORD,:DWORD,:DWORD,:DWORD

include		windows.inc
include		user32.inc
include		kernel32.inc
include		gdi32.inc
include		comdlg32.inc
includelib	user32.lib
includelib	kernel32.lib
includelib	gdi32.lib
includelib	comdlg32.lib	;paths set in c:\aw.bat

.RADIX	16
lfstyle	EQU	CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
chstyle	EQU	CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS

.DATA

LFwc	LABEL	DWORD		;LFile Window Class structure
	DD	SIZEOF WNDCLASSEX	; 0 wc.cbSize
	DD	lfstyle			; 4 wc.style
	DD	WProc			; 8 wc.lpfnWndProc
	DD	0,0			;0C wc.cbClsExtra, wc.cbWndExtra
hinst	DD	?			;14 wc.hinst
hicon	DD	?			;18 LoadIcon,0,IDI_APPLICATION
hcurs	DD	?			;1C LoadCursor,NULL,IDC_ARROW
hbkbr	DD	?			;20 CreateSolidBrush,0FF0000h
wcmen	DD	0			;24 wc.lpszMenuName
	DD	ClassName		;28 wc.lpszClassName
hiconsm	DD	?			;2C wc.hIconSm
					;30	end LFwc
LFwcc	LABEL	DWORD		;LFile Window Child Class structure
	DD	SIZEOF WNDCLASSEX	; 0
	DD	chstyle			; 4
	DD	CWProc			; 8
	DD	0,0			; C
chinst	DD	?			;14 Dwords at 14,18,1C and 2C are copied
	DD	?			;18   from LFwc in newwin
	DD	?			;1C 
	DD	?			;20 From CreateSolidBrush,0EEEE00
	DD	0			;24
	DD	ChldClass		;28 ClassName
	DD	?			;2C

ClassName	DB	"LFclass",0
AppName		DB	"testp b811",0

ChldClass	DB	"LFChildclass",0
ChildW		DB	"lfwChild",0

font1	LABEL	DWORD	;typedef struct tagLOGFONT {
	DD	?	; 0  LONG lfHeight
	DD	?	; 4  LONG lfWidth
escp	DD	0	; 8  LONG lfEscapement;
orie	DD	0	; C  LONG lfOrientation;
wght	DD	240	;10  LONG lfWeight;
ital	DB	0	;14  BYTE lfItalic;
undl	DB	0	;15  BYTE lfUnderline;
strk	DB	0	;16  BYTE lfStrikeOut;
chst	DB	OEM_CHARSET	;17  BYTE lfCharSet	-1 = OEM_CHARSET
opre	DB	0	;18  BYTE lfOutPrecision	\
cpre	DB	0	;19  BYTE lfClipPrecision	 0 = default
qual	DB	0	;1A  BYTE lfQuality		/
pfam	DB	FIXED_PITCH or FF_MODERN	;1B  BYTE lfPitchAndFamily
face	DB	"OEM_FIXED_FONT",0	;1C
			;2B  font1 ends
	ALIGN

msdat	LABEL	BYTE		;Main Screen DATA

	DB	"0          Testing Child Window Creation, etc",0
	DB	"1 23456789abcdef 123456789abcdef 123456789abcdef 123456789abcdef 123456789abcdef",0
	DB	"2",0
	DB	"3 sszh = screen size vertical = 50",0
	DB	"4 sszv = screen size vertical = 20",0
	DB	"5",0
	DB	"6    Commands:",0
	DB	"7       escape - exit",0
	DB	"8       w - open child Window",0
	DB	"9       back - beep",0
	DB	"a",0
	DB	"b",0
	DB	"c",0
	DB	"d",0
	DB	"e",0
	DB	"f",0
	DB	"10",0
	DB	"11",0
	DB	"12",0
	DB	"13",0
	DB	"14",0
	DB	"15",0
	DB	"16",0
	DB	"17",0
	DB	"18",0
	DB	"19",0
	DB	"1a",0
	DB	"1b",0
	DB	"1c",0
	DB	"1d",0
	DB	"1e",0
	DB	"1f",0
	DB	"20",0
	DB	"21",0
	DB	"22",0
	DB	"23",0
	DB	"24 Bottom Line",0
	ALIGN

sszh	DD	50	;Screen SiZe Horizontal - columns
fsszv	DD	25	;Full Screen SiZe Vertical - lines
msszv	DD	25	;Main Screen SiZe Vertical - lines
scrbf	DB	50*25 DUP (" ")	;screen buffer, 25 rows, 50 columns
flgs	DD	0	;System internal - only bits 12 and 13 used here

.DATA?

hdc	DD	?	;Handles to Device Context
hwnd	DD	?	;	to main window
cfown	DD	?	;	to window owner
hcwnd	DD	?	;	to child window
hfont1	DD	?	;	to font1

rect	LABEL	DWORD	;No separate rect for child for now.
r_lft	DD	?	;00 When we have chars in the child
r_top	DD	?	;04 we'll use the same char cell sizes.
r_rgt	DD	?	;08
r_bot	DD	?	;0C

cszh	DD	?	;Char cell SiZe Horizontal
cszv	DD	?	;Char cell SiZe Vertical

cmdl	DB	40 DUP (?)	;not used - 

ps	LABEL	DWORD	;PAINTSTRUCT
	DD	10 DUP (?)

.CODE

;;;	Initialize, Winmain

;;-	Init

;   start:	Initialize LFwc	[hbkbr],[hicon],[hiconsm],[hcurs],[hinst]

start:
	invoke	CreateSolidBrush,0FF0000h
	mov	[hbkbr], eax

	invoke	LoadIcon,0,IDI_APPLICATION
	mov	[hicon], eax
	mov	[hiconsm], eax

	invoke	LoadCursor,0,IDC_ARROW
	mov	[hcurs], eax

	invoke	GetModuleHandle, 0
	mov	[hinst], eax
	call	erbeep
;		!WinMain,hinst,0,cmdl,SW_SHOWDEFAULT	!ExitProc,eax

	invoke	WinMain,hinst,0,cmdl,SW_SHOWDEFAULT

	invoke	ExitProcess,eax

;;-	winmain

WinMain	proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

LOCAL	msg:MSG

	invoke	RegisterClassEx, OFFSET LFwc

	mov	edx, CW_USEDEFAULT
	xor	eax,eax
	invoke	CreateWindowEx,eax,ADDR ClassName,ADDR AppName,\
	WS_OVERLAPPEDWINDOW,edx,edx,edx,edx,eax,eax,hInst,eax

	mov	[hwnd], eax

	mov	[cfown], eax

	invoke	ShowWindow,hwnd,SW_SHOWMAXIMIZED

	call	gsva

	invoke UpdateWindow, hwnd

	.while TRUE
		invoke GetMessage, ADDR msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	mov   eax,msg.wParam
	ret

;   gsva:	!GetClientRect		eax  [r_bot]		div BY [fsszv]

gsva:
	invoke	GetClientRect,hwnd,ADDR rect	;Get Screen VAriables

	mov	eax, [r_bot]
	div	BYTE PTR [fsszv]

	movzx	eax, al
	mov	[cszv], eax		;Character Cell SiZe Vertical

	mov	eax, [r_rgt]
	div	BYTE PTR [sszh]

	movzx	eax, al
	mov	[cszh], eax		;Character Cell SiZe Horizontal
	retn


WinMain endp

;;;	WProc - Main Windows Procedure
;;		- Init, Messages, exit

WProc proc wp_hWnd,uMsg,wParam,lParam
	pushad

	mov	eax, [wp_hWnd]
	mov	[hwnd], eax

	mov	eax, [uMsg]		;message handling
	mov	edx, [wParam]
	mov	ecx, [lParam]

	cmp	eax, WM_DESTROY
	  jnz	@F
WPdes:	invoke	PostQuitMessage,NULL
	  jmp	WPend
@@:	cmp	eax, WM_PAINT
	  jnz	@F
	call	dspl
	  jmp	WPend
@@:	cmp	eax, WM_KEYDOWN
	  jnz	@F
	  jmp	key
	  jmp	WPend
@@:	popad
	invoke	DefWindowProc,hwnd,uMsg,wParam,lParam
	ret				;one of two rets from wproc

WPend:	popad
	xor	eax,eax
	ret

;;		- Key

key:
	cmp	dl, 1Bh		;escape
	  jz	WPdes

	cmp	dl, 57		;w
	  jnz	@F
	call	newwin
	  jmp	WPend
@@:	cmp	dl, 8		;back
	  jnz	WPend

	call	erbeep
	  jmp	WPend

;;		- DSPL  Main Display

dspl:	invoke	BeginPaint,hwnd,ADDR ps		;fills (ps) w/ defaults
	mov	[hdc], eax
	mov	edi, OFFSET font1

	mov	eax, [cszv]
	mov	[edi], eax		;height in font1

	mov	eax, [cszh]
	dec	eax
	mov	[edi+4], eax		;width in font1

	invoke	CreateFontIndirect,edi
	mov	[hfont1], eax

	invoke	SelectObject,hdc,eax

	call	dspl_0

	invoke	EndPaint,hwnd,ADDR ps

	retn

dspl_0:	invoke	SetTextColor,hdc,0FFFFFF
	invoke	SetBkColor,hdc,0FF0000		;set screen colors white on blue

	call	wscbf			;write data to scrbf
					;this 2-step process is looking ahead
					;  to when there are more data sources
	mov	esi, OFFSET scrbf
	mov	ecx, [msszv]

	xor	edi, edi		;vertical position, logical units
	mov	ebx, edi		;horizontal position
;	add	edi, [cszv]		;??? If edi starts at 0, as it should,
;	dec	edi			;??? all's fine except titlebar over-
			;??? writes line 0 - of course, it's WinDbg,'s t-bar!

dspl_lp:
	push	ecx
	invoke	TextOut,hdc,ebx,edi,esi,[sszh]
	add	edi, [cszv]		;each line is cszv in height
	add	esi, [sszh]
	pop	ecx

	loop	dspl_lp
	retn

wscbf:	mov	esi, OFFSET msdat
	mov	edi, OFFSET scrbf
	mov	edx, [msszv]

wscbf_lp0:
	mov	ecx, [sszh]
	call	wscbf_lp
	dec	edx
	  jnz	wscbf_lp0
	retn

wscbf_lp:
	lodsb
	or	al, al
	  jz	wscbf_lpe
	stosb
	loop	wscbf_lp
	inc	esi		;skip the "0" if there are sszh chars
wscbf_lpe:
	add	edi, ecx
	retn


;;	NEWWIN	NEW child WINdow

newwin:	test	BYTE PTR [flgs+2],8		;Is class registered?
	  jnz	newwin_0

	mov	esi, OFFSET hinst	;LFwc+14
	mov	edi, OFFSET chinst
	mov	ecx, 3
	rep	movsd			;hinst,hicon,hcurs
	mov	eax, [esi+0C]		;hiconsm
	mov	[edi+0C], eax		;- copy main window's values

	invoke	CreateSolidBrush,0EEEE00
	mov	[edi], eax		;edi left at LFwcc +14+0C = 20

	invoke	RegisterClassEx, OFFSET LFwcc
	or	eax, eax
	  jz	erbeep

	or	BYTE PTR [flgs+2],8		;s,13 - child class registered

newwin_0:
	mov	edx, CW_USEDEFAULT
	xor	eax,eax
	mov	esi, OFFSET ChldClass
	mov	edi, OFFSET ChildW

	invoke	CreateWindowEx,eax,esi,edi,chstyle,edx,edx,edx,edx,\
		hwnd,0,hinst,eax
	mov	[hcwnd], eax
	or	eax, eax
	  jz	erbeep

	invoke	ShowWindow, hcwnd,SW_SHOWNORMAL

	retn

	WProc endp

;;;	CWProc

CWProc proc cwphw,msg,wparam,lparam

	pushad

	or	BYTE PTR [flgs+2],4		;child exists

	mov	edx, [wparam]
	mov	ecx, [lparam]
	mov	eax, [msg]

	cmp	eax, WM_DESTROY
	  jnz	@F
CWPdes:	invoke	DestroyWindow,cwphw
	  jmp	CWPend
@@:	cmp	eax, WM_PAINT
	  jnz	@F
;	call	cdspl
	  jmp	CWPend
@@:	cmp	eax, WM_KEYDOWN
	  jnz	@F
	call	ckey
	  jmp	CWPend
@@:	popad
	invoke	DefWindowProc,hwnd,msg,wparam,lparam
	ret				;one of two rets from CWProc

CWPend:	popad
	xor	eax,eax
	ret				;the other

;;	CKEY	Child KEY functions

ckey:
	cmp	dl, 1Bh
	  jz	CWPdes
	cmp	dl, 8
	  jz	ckey_par
	cmp	dl, 23
	  jz	ckey_test
	call	erbeep
	  jmp	CWPend

ckey_test:
	call	erbeep
	call	erbeep
	  jmp	CWPend

ckey_par:
	invoke	SetFocus,hwnd
	or	eax, eax
	  jnz	@F
	call	erbeep
@@:	and	BYTE PTR [flgs+2],not 4	;s,12 - child w valid
	  jmp	CWPend

	CWProc endp

;;	ERBEEP	ERror BEEP

erbeep:
	invoke	Beep,0B00,0B0

	retn
	END	start